%if 0%{?fedora}
%global with_python3 1
%endif

%global modname pyramid_tm

Name:           python-pyramid-tm
Version:        0.12
Release:        2%{?dist}
Summary:        A package which allows Pyramid requests to join the active transaction

Group:          Development/Languages
License:        BSD
URL:            http://pypi.python.org/pypi/pyramid_tm
Source0:        http://pypi.python.org/packages/source/p/%{modname}/%{modname}-%{version}.tar.gz
Patch0:         python-pyramid-tm-remove-block.patch

BuildArch:      noarch


BuildRequires:  python2-devel
BuildRequires:  python-setuptools
BuildRequires:  python-pyramid
BuildRequires:  python-transaction
BuildRequires:  python-nose
BuildRequires:  python-coverage

Requires:       python-pyramid
Requires:       python-transaction

%if 0%{?with_python3}
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-pyramid
BuildRequires:  python3-transaction
BuildRequires:  python3-nose
BuildRequires:  python3-coverage
%endif


%description
pyramid_tm is a package which allows Pyramid requests to join the
active transaction as provided by the transaction
http://pypi.python.org/pypi/transaction

See http://docs.pylonsproject.org/projects/pyramid_tm/dev/
or docs/index.rst in this distribution for detailed documentation.

%if 0%{?with_python3}
%package -n python3-pyramid-tm
Summary:        A package which allows Pyramid requests to join the active transaction
Group:          Development/Languages

Requires:       python3-pyramid
Requires:       python3-transaction

%description -n python3-pyramid-tm
pyramid_tm is a package which allows Pyramid requests to join the
active transaction as provided by the transaction
http://pypi.python.org/pypi/transaction

See http://docs.pylonsproject.org/projects/pyramid_tm/dev/
or docs/index.rst in this distribution for detailed documentation.
%endif

%prep
%setup -q -n %{modname}-%{version}

# Remove a block that requires a more modern version of
# python-transaction if we're on el6.
%if 0%{?rhel} && 0%{?rhel} <= 6
%patch0 -p1
%endif


# Make sure that setuptools picks the right version of zope.interface (el6)
awk 'NR==1{print "import __main__; __main__.__requires__ = __requires__ = [\"zope.interface>=3.8\"]; import pkg_resources"}1' setup.py > setup.py.tmp
mv setup.py.tmp setup.py

# Remove bundled egg info
rm -rf %{modname}.egg-info

%if 0%{?with_python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
%endif

%build
%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py build
popd
%endif

%{__python} setup.py build

%install
%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py install --skip-build --root=%{buildroot}
popd
%endif

%{__python} setup.py install -O1 --skip-build --root %{buildroot}

%check
%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py test
popd
%endif

%if 0%{?rhel} && 0%{?rhel} <= 6
# Don't run the tests on el6, some of the deps there are too old.
%else
%{__python} setup.py test
%endif


%files
%doc README.rst docs CONTRIBUTORS.txt CHANGES.rst
%license LICENSE.txt COPYRIGHT.txt
%{python_sitelib}/%{modname}
%{python_sitelib}/%{modname}-%{version}*

%if 0%{?with_python3}
%files -n python3-pyramid-tm
%doc README.rst docs CONTRIBUTORS.txt CHANGES.rst
%license LICENSE.txt COPYRIGHT.txt
%{python3_sitelib}/%{modname}
%{python3_sitelib}/%{modname}-%{version}*
%endif


%changelog
* Tue Nov 10 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.12-2
- Rebuilt for https://fedoraproject.org/wiki/Changes/python3.5

* Tue Sep 15 2015 Ralph Bean <rbean@redhat.com> - 0.12-1
- new version
- Move license and copyright to a %%license field.

* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri May 30 2014 Bohuslav Kabrda <bkabrda@redhat.com> - 0.7-4
- Rebuilt for https://fedoraproject.org/wiki/Changes/Python_3.4

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Jun 21 2013 Ralph Bean <rbean@redhat.com> - 0.7-2
- Patch to remove a block that requires python-transaction>=1.1 which is
  unavailable on el6.

* Fri Jun 21 2013 Ralph Bean <rbean@redhat.com> - 0.7-1
- Latest upstream
- Added python3 subpackage.
- Added test suite to check section.
- Included upstream docs.
- Write unauthenticated userid and request.path_info as transaction metadata
  via t.setUser and t.note respectively during a commit.
- Disuse the confusing and bug-ridden generator-plus-context-manager "attempts"
  mechanism from the transaction package for retrying retryable exceptions
  (e.g. ZODB ConflictError). Use a simple while loop plus a counter and
  imperative logic instead
- When a non-retryable exception was raised as the result of a call to
  transaction.manager.commit, the exception was not reraised properly. Symptom:
  an unrecoverable exception such as Unsupported: Storing blobs in
  <somestorage> is not supported. would be swallowed inappropriately.

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon Jun 18 2012 Ross Delinger <rossdylan@csh.rit.edu> 0.4-1
- initial package for Fedora
